//+--------------------------------------------------------------------------+
//|                                                                          |
//|                               Accordion                                  |
//|                                                                          |
//|                       GDImage accordion effect                           |
//|                                                                          |
//|                     WinLIFT64.dll, GDImage64.dll                         |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                            copyright(c) 2014                             |
//|                           www.zapsolution.com                            |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 04-28-2014 (MM-DD-YYYY)            |
//|                        Last revised : 05-02-2014 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#include <windows.h>
#include <WinBase.h>
#include <Shlwapi.h>
//#include <Dwmapi.h>
#include <time.h>
#include <locale.h>

#include "Tools.h"

#pragma comment(lib, "..\\GDImage64.lib")
#pragma comment(lib, "..\\WinLIFT64.lib")

#define ClientWidth      910
#define ClientHeight     512
#define IDC_GDIMAGE       -1

struct PROP {
    HWND  gdimage;
    long  currentID;
    long  lastID;
    WCHAR FontToUse[MAX_PATH];
    long  fontsize;
    long  fontID;
} ;

PROP gP; // Global accordeon properties

LRESULT CALLBACK MouseMoveCallBack(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    LRESULT nRet = FALSE; // Do not stop the event processing in GDImage

    long nID = ZI_MouseOverObjectID();

    if ( (nID != gP.currentID) && (nID < gP.fontID) ) {
        long K = 0;
        for (K = nID + 1; K < gP.lastID + 1; ++K ) {
             ZD_SetObjectZorder(K, ZD_ORDER_BOTTOM);
        }
        for (K = 1; K < nID; ++K ) {
             ZD_SetObjectZorder(K, K);
        }

        ZD_SetObjectZorder(nID, ZD_ORDER_TOP);

        WCHAR szFile[MAX_PATH]; PathCombine(szFile, EXEresource(), L"blup.wav");
        PlaySound(szFile, NULL, SND_FILENAME | SND_ASYNC);

        ZOBJECT z; ZD_GetObjectProperties(nID, z);
        long xPos = z.x1, nWidth = z.x2, nStep = 256;
        K = nWidth - nStep;
        while (K < nWidth) {
            K = nWidth - nStep;
            z.x2 = K;
            if (nID > gP.currentID) { z.x1 = xPos + nWidth - z.x2; }
            ZD_SetObjectProperties(nID, z);
            ZD_SetObjectAlpha (nID, 255, TRUE);
            nStep /= 2;
        }
        z.x2 = nWidth; z.x1 = xPos; ZD_SetObjectProperties(nID, z);

        // Update the image caption name
        ZD_SetObjectZorder(gP.fontID, ZD_ORDER_TOP);
        ZD_SetObjectXY(gP.fontID, z.x1 + 10, z.y1 + 10, FALSE);
        ZD_SetObjectTextEx(gP.fontID, ZD_GetObjectImageLabel(nID), TRUE);

        gP.currentID = nID;

    }

    return nRet;
}

long DetectImageExtension(IN WCHAR* zFileName) {
    long nRet = 0;
    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT + 1];
    if (zFileName) {
        _wsplitpath_s(zFileName, drive, dir, fname, ext);
        if (wcslen(ext)) {
            wcsncat_s(ext, L".", 1);
            CharLower(ext);
            if (wcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) { nRet = -1; }
        }
    }
    return nRet;
}

void GDImageSetup() {
    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT + 1];
    long nID = 0, x = 0, y = 0, w = 0, h = 0, xPos = 0;
    HBITMAP hBitmap = 0;
    HANDLE hFind = 0;
    WIN32_FIND_DATA fd = { 0 };
    WCHAR szResource[MAX_PATH]; wcscpy_s(szResource, EXEresource());
    WCHAR szSearch[MAX_PATH]; PathCombine(szSearch, szResource, L"*.*");
    hFind = FindFirstFile(szSearch, &fd);
    if (hFind != INVALID_HANDLE_VALUE) {
        do {
            if (fd.cFileName[0] != 46) {
                switch (fd.dwFileAttributes) {
                case 0:
                case 1:
                case 32:
                case 33:
                case 128:
                     PathCombine(szSearch, szResource, fd.cFileName);
                     if (DetectImageExtension(szSearch)) {
                         hBitmap = ZI_FitBitmapFromFile(szSearch, ClientWidth, ClientHeight);
                         if (hBitmap) {
                             ++nID;
                             ZD_DrawBitmapToCtrl(gP.gdimage, x, y, hBitmap, 0xFFFFFFFF, nID, ZS_VISIBLE);
                             ZD_SetObjectLocked(nID, TRUE);
                             _wsplitpath_s(szSearch, drive, dir, fname, ext);
                             ZD_SetObjectImageLabel(nID, fname);
                         }
                     }
                     break;
                }
            }
        }
        while (FindNextFile(hFind, &fd) != 0);
        FindClose(hFind);
    }
    gP.lastID = nID;
    gP.currentID = gP.lastID;

    x = 0, y = 0;
    long nOffset = (ClientWidth - ClientHeight) / (gP.lastID - 1) + 1;
    for (nID = 1; nID <= gP.lastID; nID++) {
         ZD_GetObjectBound(nID, w, h);
         hBitmap = ZI_CropBitmap(ZD_GetObjectBitmap(nID), (w - h) / 2, 0, ClientHeight, ClientHeight, 0);
         ZD_DrawBitmapToCtrl(gP.gdimage, x, y, hBitmap, 0xFFFFFFFF, nID, ZS_VISIBLE);
         x += nOffset;
    }

    PathCombine(gP.FontToUse, EXEresource(),L"ft00.ttf"); // We use a private font.
    gP.fontsize = 25;
    gP.fontID = gP.lastID + 1;
    ZD_GetObjectXY(gP.currentID, x, y);
    short nUse3D = -1;
    ZD_DrawTextToCtrlEx(gP.gdimage, ZD_GetObjectImageLabel(gP.lastID), x + 10, y + 10, ClientHeight - 20, 100, ZD_ARGB(255, 255,255,255),
                        gP.FontToUse, gP.fontsize, gP.fontID, ZS_VISIBLE, nUse3D, StringAlignmentNear);
    ZD_SetObjectLocked(gP.fontID, TRUE);

    // IMPORTANT, this is our mouse callback, where we manage the display of the accordion.
    ZI_EventMessageEx(gP.gdimage, (LONG_PTR) MouseMoveCallBack, WM_MOUSEMOVE, TRUE);
}

// Main winproc
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    //long wmId, wmEvent;
    //PAINTSTRUCT ps;
    //HDC hdc;

    //switch (uMsg) {
    //case WM_COMMAND:
    //     wmId    = LOWORD(wParam);
    //     wmEvent = HIWORD(wParam);
    //     return 0;

    //case WM_PAINT:
    //     hdc = BeginPaint(hWnd, &ps);
    //     // TODO: process here the WM_PAINT message...
    //     EndPaint(hWnd, &ps);
    //     return 0;

    //case WM_DESTROY:
    //     PostQuitMessage(0);
    //     return 0;
    //}
   
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}  

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Declaration of local variables
    long nRet = 0, IsInitialized = 0;
    WNDCLASSEX wcx; MSG msg;
    WCHAR szWindowClass[] = L"ACCORDION";
    WCHAR szTitle[64];
    wcscpy_s(szTitle, L"GDImage accordion ");
    if (sizeof(LONG_PTR) == 8) {
        wcsncat_s(szTitle, L"64-bit", 6);
    } else {
        wcsncat_s(szTitle, L"32-bit", 6);
    }

    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized) {
         wcx.style         = CS_HREDRAW | CS_VREDRAW;
         wcx.lpfnWndProc   = WndProc;
         wcx.cbClsExtra    = 0;
         wcx.cbWndExtra    = 0;
         wcx.hInstance     = hInstance;
         wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
         wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
         wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
         wcx.lpszMenuName  = NULL;
         wcx.lpszClassName = szWindowClass;
         wcx.hIconSm       = LoadIcon(wcx.hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
         if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
     }

     if (IsInitialized) {  
         RECT r = { 0 };
         DWORD dwExStyle = 0;
         DWORD dwStyle = WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_CLIPSIBLINGS | WS_CLIPCHILDREN; // | WS_VISIBLE
         SetRect(&r, 0, 0, ClientWidth, ClientHeight);
         AdjustWindowRectEx(&r, dwStyle, FALSE, dwExStyle);
         long w = r.right - r.left;
         long h = r.bottom - r.top;
         long x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
         long y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

         HWND hWnd = CreateWindowEx(
                     0,                              // Optional window styles.
                     szWindowClass,                  // Window class
                     szTitle,                        // Window text
                     dwStyle,                        // Window style
                     // Size and position
                     x, y, w, h,
                     NULL,       // Parent window    
                     NULL,       // Menu
                     hInstance,  // Instance handle
                     NULL        // Additional application data
                     );
    
        if (hWnd) {

            RegisterGDImageClass();
            gP.gdimage = CreateWindowEx(0, GDImageClassName, L"", WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                                        0, 0, ClientWidth, ClientHeight, hWnd, (HMENU)IDC_GDIMAGE, hInstance, NULL);
            if (gP.gdimage) {
                skSkinDisable(gP.gdimage); // Do not skin the main GDImage control.
                WCHAR szFile[MAX_PATH] = { 0 };
                PathCombine(szFile, EXEpath(), L"AccordionSkin.sks");
                if (skInitEngine (szFile, L"")) {
                    skSkinWindow(hWnd, L"Dock|Undock|Minimize|Maximize|Restore|Close");
                }
                GDImageSetup();
            }

            ShowWindow(hWnd, nCmdShow);
            UpdateWindow(hWnd);
    
            // Main message loop
            while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            nRet = (long) msg.wParam;
        }
     }
     return nRet;
}
