#include "GDImage.h"
#include "WinLIFT.h"

// GDIPLUS Flat API
#ifndef _GDIPLUS_H
#define _GDIPLUS_H
struct IDirectDrawSurface7;
typedef signed   short  INT16;
typedef unsigned short  UINT16;
#include <pshpack8.h>   // set structure packing to 8
namespace DllExports {
#include "GdiplusMem.h"
};
#include "GdiplusBase.h"
#include "GdiplusEnums.h"
#include "GdiplusTypes.h"
#include "GdiplusInit.h"
#include "GdiplusPixelFormats.h"
#include "GdiplusColor.h"
#include "GdiplusMetaHeader.h"
#include "GdiplusImaging.h"
#include "GdiplusGpStubs.h"
#include "GdiplusHeaders.h"
#endif // !_GDIPLUS_HPP

#define short_proc typedef short (__stdcall *zProc)
#define long_proc typedef long (__stdcall *zProc)
#define char_proc typedef char* (__stdcall *zProc)
#define wchar_proc typedef WCHAR* (__stdcall *zProc)
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16)) 

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*)longstr;
}

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

WCHAR* TIME() {
    time_t now = time(0);
    tm tstruct;
    static WCHAR buf[16] = {0};
    if (localtime_s(&tstruct, &now) == 0) {
        wcsftime(buf, strSize(buf), L"%X", &tstruct);
        buf[5] = 32; buf[6] = 0; buf[7] = 0;
    }
    return buf;
}

WCHAR* TODAY() {
    time_t now = time(0);
    tm tstruct;
    static WCHAR buf[32] = {0};
    if (localtime_s(&tstruct, &now) == 0) {
        _wcsftime_l(buf, strSize(buf), L"%A, %d %B", &tstruct, _create_locale(LC_ALL, ""));
    }
    return buf;
}

BOOL FileExist(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    BOOL bRet = FALSE;
    if (wcslen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            bRet = TRUE;
        }
    }
    return bRet;
}

DWORD FileSize(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    DWORD nRet = 0;
    if (wcslen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

WCHAR* TEMPpath() {
    static WCHAR buf[MAX_PATH];
    DWORD nSize = GetTempPath(GetTempPath(NULL, NULL), &buf[0]);
    if (nSize) {
        if (!FileExist(buf)) { CreateDirectory(buf, NULL); }
    }
    return buf;
}

WCHAR* EXEpath() {
    static WCHAR exepath[MAX_PATH] = {0};
    if (GetModuleFileName(0, exepath, sizeof(exepath))) {
        long nLen = (long)wcslen(exepath);
        long nPos = nLen;
        for (long K = 1; K <= nLen; K++) {
            if (_wcsicmp(&exepath[nPos - K], L"\\") != 0) { exepath[nPos - K] = NULL; }
            else { break; }
        }
    }
    return exepath;
}

WCHAR* EXEresource() {
    static WCHAR exeresource[MAX_PATH] = {0};
    PathCombine(exeresource, EXEpath(), L"Resource\\");
    return exeresource;
}

void ListDeleteAll(IN HWND hList) {
    if (hList) { SendMessage(hList, LB_RESETCONTENT, 0, 0); }
}

void ListDeleteItem(IN HWND hList, IN long nIndex) {
     if (hList) {
         if (nIndex > 0) {
             -- nIndex; // Because ListBox is zero based
             SendMessage(hList, LB_DELETESTRING, (WPARAM) nIndex, (LPARAM) 0);
         }
     }
}

LRESULT ListAdd(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
       if (wcslen(zTmp)) { nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

long ListCount(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) { nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0); }
    return nRet;
}

LRESULT ListFindString(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
        nIndex = SendMessage(hList, LB_FINDSTRINGEXACT, -1, (LPARAM) zTmp);
        if (nIndex > -1) { ++nIndex; }
    }
    return nIndex;
}

void ListSelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex < 0) { hList = 0; }
    if (hList) {
        if (nIndex > 0) { --nIndex; } // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0); 
    }
}

WCHAR* ListGetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    memset(szData, 0, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

long ListGetCursel(IN HWND hList) {
    long nIndex = 0;
    if (hList) {
       nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
       if (nIndex > -1) { ++nIndex; } // Because ListBox is zero based
    }
    return nIndex;
}

//// This is the most IMPORTANT API to create a transparent window
//// We fool DWM with a fake region, because we want to use the client, and the non-client area,
//// just like with a transparent layered window.
//// This one must also be used with Windows 8+
//void zSetCrystalBehindMode(IN HWND hWnd, IN BOOL nBOOL) {
//    if (nBOOL) {
//        HRGN hRgnBlur = 0;
//        DWM_BLURBEHIND bb = {0};
//        // Create and populate the BlurBehind structure.
//        // Set Blur Behind and Blur Region.
//        bb.fEnable = nBOOL;
//        bb.dwFlags = DWM_BB_ENABLE | DWM_BB_BLURREGION;
//        bb.fTransitionOnMaximized = 0;
//        // Fool DWM with a fake region
//        if (nBOOL) { hRgnBlur = CreateRectRgn(-1, -1, 0, 0); } // <--- Create the full transparent rectangular region
//        bb.hRgnBlur = hRgnBlur;
//        // Set Blur Behind mode.
//        LRESULT nRet = DwmEnableBlurBehindWindow(hWnd, &bb);
//    }
//}

HMODULE gdiplib() {
    static HMODULE hGdip;
    if (hGdip == 0) { hGdip = LoadLibrary(L"GDIPLUS"); }
    return hGdip;
}

long Load_GDIPLUS() {
    long nRet = 0;
    if (gdiplib()) { nRet = -1; }
    return nRet;
}

long GdiplusStart(OUT LONG_PTR &hGDIplus, GdiplusStartupInput &inputbuf, IN LONG_PTR outputbuf) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR*, GdiplusStartupInput*, LONG_PTR);
        zProc hPROC = (zProc)GetProcAddress(hModule, "GdiplusStartup");
        if (hPROC) {
            nRet = hPROC(&hGDIplus, &inputbuf, outputbuf);
        }
    }
    return nRet;
}

long GdiplusShutdown(IN LONG_PTR hGDIplus) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR);
        zProc hProc = (zProc)GetProcAddress(hModule, "GdiplusShutdown");
        if (hProc) { nRet = hProc(hGDIplus); }
    }
    return nRet;
}

long GdipLoadImageFromFile(IN WCHAR* szImgName, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    lpImg = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(WCHAR*, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipLoadImageFromFile"); }
        if (hProc) { nRet = hProc(szImgName, &lpImg); }
    }
    return nRet;
}

long GdipDeleteGraphics(IN LONG_PTR graphics) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDeleteGraphics"); }
        if (hProc) { nRet = hProc(graphics); }
    }
    return nRet;
}

long GdipDrawImageRectRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long dstX, IN long dstY, IN long dstW, IN long dstH, IN long srcX, IN long srcY, IN long srcW, IN long srcH, IN long srcUnit, IN LONG_PTR imageattr, IN LONG_PTR lpCallback, IN LONG_PTR callbackdata) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, LONG_PTR, long, long, long, long, long, long, long, long, long, LONG_PTR, LONG_PTR, LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDrawImageRectRectI"); }
        if (hProc) { nRet = hProc(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata); }
    }
    return nRet;
}

long GdipDisposeImage(IN LONG_PTR lpImg) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDisposeImage"); }
        if (hProc) { nRet = hProc(lpImg); }
    }
    return nRet;
}

long GdipGetImageWidth(IN LONG_PTR lpImg, OUT long &imgW) {
    long nRet = -1; // Error
    imgW = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, long*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipGetImageWidth"); }
        if (hProc) { nRet = hProc(lpImg, &imgW); }
    }
    return nRet;
}

long GdipGetImageHeight(IN LONG_PTR lpImg, OUT long &imgH) {
    long nRet = -1; // Error
    imgH = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, long*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipGetImageHeight"); }
        if (hProc) { nRet = hProc(lpImg, &imgH); }
    }
    return nRet;
}

long GdipCreateFromHDC(IN HDC hDC, OUT LONG_PTR &graphics) {
    long nRet = -1; // Error
    graphics = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(HDC, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipCreateFromHDC"); }
        if (hProc) { nRet = hProc(hDC, &graphics); }
    }
    return nRet;
}

long GdipCreatePen1(long ARGB, IN float size, IN long unit, OUT LONG_PTR &pen) {
    long nRet = -1; // Error
    pen = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(long, float, long, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipCreatePen1"); }
        if (hProc) { nRet = hProc(ARGB, size, unit, &pen); }
    }
    return nRet;
}

long GdipDrawLineI(IN LONG_PTR graphics, IN LONG_PTR hPen, IN long x1, IN long y1, IN long x2, IN long y2) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, LONG_PTR, long, long, long, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDrawLineI"); }
        if (hProc) { nRet = hProc(graphics, hPen, x1, y1, x2, y2); }
    }
    return nRet;
}

long GdipDeletePen(IN LONG_PTR hPen) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDeletePen"); }
        if (hProc) { nRet = hProc(hPen); }
    }
    return nRet;
}

long GdipCreateHBITMAPFromBitmap(IN LONG_PTR hImage, OUT HBITMAP &hBitmap, IN long ARGB) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, HBITMAP*, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipCreateHBITMAPFromBitmap"); }
        if (hProc) { nRet = hProc(hImage, &hBitmap, ARGB); }
    }
    return nRet;
}

long GdipCreateBitmapFromHBITMAP(IN HBITMAP hbm, IN LONG_PTR hpal, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    lpImg = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(HBITMAP, LONG_PTR, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipCreateBitmapFromHBITMAP"); }
        if (hProc) { nRet = hProc(hbm, hpal, &lpImg); }
    }
    return nRet;
}

long GdipCreateSolidFill(IN long ARGB, OUT LONG_PTR &gdipBrush) {
    long nRet = -1; // Error
    gdipBrush = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(long, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipCreateSolidFill"); }
        if (hProc) { nRet = hProc(ARGB, &gdipBrush); }
    }
    return nRet;
}

long GdipFillRectangleI(IN LONG_PTR graphics, IN LONG_PTR gdipBrush, IN long x, IN long y, IN long xW, IN long yH) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR, LONG_PTR, long, long, long, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipFillRectangleI"); }
        if (hProc) { nRet = hProc(graphics, gdipBrush, x, y, xW, yH); }
    }
    return nRet;
}

long GdipDeleteBrush(IN LONG_PTR gdipBrush) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc(LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hModule, "GdipDeleteBrush"); }
        if (hProc) { nRet = hProc(gdipBrush); }
    }
    return nRet;
}

LONG_PTR GdipStart() {
    LONG_PTR hGDIplus = 0;
    if (Load_GDIPLUS()) {
        // Load the GDI+ Dll
        GdiplusStartupInput GpInput;
        GpInput.GdiplusVersion = 1;
        if (GdiplusStart(hGDIplus, GpInput, NULL) != 0) { hGDIplus = 0; }
    }
    return hGDIplus;
}

void GdipEnd(IN LONG_PTR hGDIplus) {
    if (hGDIplus) { GdiplusShutdown(hGDIplus); }
}

HBITMAP ResizeWithVariableOpacity(IN WCHAR* szFile, IN long w, IN long h) { 
    HBITMAP hBitmap = 0;
    HBITMAP hTmpBitmap = ZI_ResizeBitmapFromFile(szFile, w + 16, h + 16);
    if (hTmpBitmap) {
        hBitmap = ZI_CropBitmap(hTmpBitmap, 8, 8, w, h, 0); // Clip to remove unwanted borders
        if (hBitmap) {
            BITMAP bm; GetObject(hBitmap, sizeof(bm), &bm);
            BYTE* pBits = (BYTE*) bm.bmBits;
            for (long p = 0; p < (bm.bmWidth * bm.bmHeight); ++p) {
                pBits[3] = Rgb2Alpha(RGB(pBits[2],pBits[1],pBits[0]));
                pBits += 4;
            }
        }
        DeleteObject (hTmpBitmap);
    }
    return hBitmap;
}